<template>
  <div class="flex flex-col h-full">
    <PageHeader
      :loading="isLoading"
      @refresh="fetchData"
    />

    <Viewport>
      <section class="block sm:flex items-end justify-between">
        <section>
          <v-btn
            v-if="$route.query.fromGuest"
            prepend-icon="mdi-arrow-u-left-top"
            text="К гостю"
            variant="text"
            class="text-teal-700"
            @click="$router.push(`/guests/${$route.query.fromGuest}`)"
          />

          <v-btn
            v-else-if="$route.query.fromDashboard"
            prepend-icon="mdi-arrow-u-left-top"
            text="К статистике"
            variant="text"
            class="text-teal-700"
            @click="$router.push('/dashboard')"
          />

          <v-btn
            v-else
            prepend-icon="mdi-arrow-u-left-top"
            text="К бронированиям"
            variant="text"
            class="text-teal-700"
            @click="$router.push('/bookings')"
          />
        </section>

        <v-list-item
          v-if="isLoading || !booking"
          lines="two"
          class="!p-0 mt-2 sm:mt-0"
        >
          <template #title>
            <v-skeleton-loader
              width="256"
              height="16"
            />
          </template>

          <template #subtitle>
            <v-skeleton-loader
              width="128"
              height="16"
              class="mt-2"
            />
          </template>
        </v-list-item>

        <section
          v-if="!isLoading && booking"
          class="flex items-center gap-2 flex-row-reverse sm:flex-row justify-end sm:justify-start"
        >
          <v-list-item
            lines="two"
            class="!p-0 mt-2 sm:mt-0"
          >
            <template #title>
              <span class="text-gray-500 text-sm">
                Бронирование #{{ String(booking.id).padStart(4, '0') }}
              </span>
            </template>

            <template #subtitle>
              <span class="text-gray-500 text-sm">
                от {{ dt.display(booking.createdAt) }}
              </span>
            </template>
          </v-list-item>

          <v-scroll-y-transition>
            <v-btn
              v-if="booking.status === BookingStatus.BOOKED"
              v-tooltip="{ text: 'Отмена бронирования', openOnClick: true }"
              variant="tonal"
              icon="mdi-calendar-remove-outline"
              class="ml-2 text-red-400"
              size="small"
              @click="isCancelConfirmShown = true"
            />
          </v-scroll-y-transition>
        </section>
      </section>

      <Feedback
        :message="feedback"
        class="mt-4"
        type="error"
      />

      <BookingPageSkeleton v-if="isLoading || !booking" />

      <section
        v-if="!isLoading && booking"
        class="grid grid-cols-12 gap-4 xl:gap-6 mt-4"
      >
        <section class="col-span-12">
          <GeneralDisplay
            :booking="booking"
            @update:status="onStatusUpdate"
          />
        </section>

        <section class="col-span-12 md:col-span-6 row-span-2">
          <DatesDisplay
            :booking="booking"
            @update:dates="onDatesUpdate"
          />
        </section>

        <section class="col-span-12 md:col-span-6">
          <RateDisplay :booking="booking" />
        </section>

        <section class="col-span-12 md:col-span-6">
          <CommentDisplay
            :booking="booking"
            @update:comment="onCommentUpdate"
          />
        </section>
      </section>

      <section
        v-if="!isLoading && booking"
        class="block md:flex gap-0 md:gap-4 xl:gap-6 mt-4 xl:mt-6"
      >
        <section class="flex-auto basis-1/2 h-fit">
          <GuestsDisplay
            :booking="booking"
            @update:guests-count="onGuestsCountUpdate"
          />
        </section>

        <section class="flex-auto basis-1/2 mt-4 md:mt-0">
          <section>
            <AmenitiesDisplay
              :booking="booking"
              @update:amenities="onAmenitiesUpdate"
            />
          </section>

          <section class="mt-4 xl:mt-6 h-fit">
            <CorrectionsDisplay
              :booking="booking"
              @update:corrections="onCorrectionsUpdate"
            />
          </section>
        </section>
      </section>
    </Viewport>
  </div>

  <ConfirmationDialog
    v-model="isCancelConfirmShown"
    :is-loading="isOverlayLoading"
    confirm-btn-icon="mdi-calendar-remove-outline"
    confirm-btn-label="Подтвердить"
    @confirm="onCancelClick"
  >
    Вы действительно хотите отменить это бронирование?
  </ConfirmationDialog>

  <v-overlay
    :model-value="isOverlayLoading"
    class="items-center justify-center"
    scrim="white"
    persistent
  >
    <v-progress-circular
      color="var(--tw-color-teal-600)"
      size="64"
      indeterminate
    />
  </v-overlay>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { useRouter } from 'vue-router';

import { HttpClient } from '@/http';
import { BookingStatus } from '@/declarations';
import { useDateTime } from '@/composables';
import { sleep } from '@/utils';

import Viewport from '@/components/layout/Viewport.vue';
import PageHeader from '@/components/layout/PageHeader.vue';
import Feedback from '@/components/content/Feedback.vue';
import BookingPageSkeleton from '@/components/skeletons/BookingPageSkeleton.vue';

import GeneralDisplay from './page/GeneralDisplay.vue';
import DatesDisplay from './page/DatesDisplay.vue';
import GuestsDisplay from './page/GuestsDisplay.vue';
import RateDisplay from './page/RateDisplay.vue';
import AmenitiesDisplay from './page/AmenitiesDisplay.vue';
import CorrectionsDisplay from './page/CorrectionsDisplay.vue';
import CommentDisplay from './page/CommentDisplay.vue';
import ConfirmationDialog from '@/components/layout/ConfirmationDialog.vue';

const router = useRouter();
const dt = useDateTime();

const isLoading = ref(false);
const isOverlayLoading = ref(false);
const isCancelConfirmShown = ref(false);
const feedback = ref('');

const booking = ref<IVerboseBooking | null>(null);

const fetchData = async () => {
  isLoading.value = true;

  const id = router.currentRoute.value.params.id;
  const { data: { values, error } } = await HttpClient.get<IVerboseBooking>(`/v1/bookings/${id}`);

  if (error) {
    feedback.value = error.message;
    return;
  }

  booking.value = values;
  isLoading.value = false;
};

const onStatusUpdate = async (status: BookingStatus) => {
  isOverlayLoading.value = true;

  // Improve animation a bit
  await sleep(100);

  const { data: { error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/status`,
    { status },
  );

  if (!error) {
    booking.value!.status = status;
  }

  isOverlayLoading.value = false;
};

const onCancelClick = async () => {
  isOverlayLoading.value = true;
  isCancelConfirmShown.value = false;

  const { data: { error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/status`,
    { status: BookingStatus.CANCELLED },
  );

  if (!error) {
    booking.value!.status = BookingStatus.CANCELLED;
  }

  isOverlayLoading.value = false;
};

const onCommentUpdate = async (comment: string) => {
  isOverlayLoading.value = true;

  const { data: { error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/comment`,
    { comment },
  );

  if (!error) {
    booking.value!.comment = comment;
  }

  isOverlayLoading.value = false;
};

const onGuestsCountUpdate = async (
  { adults, children }: Pick<IVerboseBooking, 'adults' | 'children'>,
) => {
  isOverlayLoading.value = true;

  const { data: { values, error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/guests/count`,
    { adults, children },
  );

  if (!error) {
    booking.value!.adults = adults;
    booking.value!.children = children;
    booking.value!.totalProfit = values.totalProfit;
  }

  isOverlayLoading.value = false;
};

const onAmenitiesUpdate = async (
  amenities: Pick<IBookingAmenity, 'id' | 'quantity'>[],
) => {
  isOverlayLoading.value = true;

  const payload = amenities.map(({ id: amenityId, quantity }) => {
    return { amenityId, quantity };
  });

  const { data: { values, error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/amenities`,
    { amenities: payload },
  );

  if (!error) {
    booking.value!.amenities = values.amenities;
    booking.value!.totalProfit = values.totalProfit;
  }

  isOverlayLoading.value = false;
};

const onCorrectionsUpdate = async (
  corrections: IProfitCorrection[],
) => {
  isOverlayLoading.value = true;

  const payload = corrections.reduce<IProfitCorrection[]>((result, correction) => {
    if (Number(correction.value) !== 0) {
      result.push({ ...correction, value: Number(correction.value) });
    }

    return result;
  }, []);

  const { data: { values, error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/corrections`,
    { corrections: payload },
  );

  if (!error) {
    booking.value!.corrections = values.corrections;
    booking.value!.totalProfit = values.totalProfit;
  }

  isOverlayLoading.value = false;
};

const onDatesUpdate = async (
  { endDate }: { endDate: string },
) => {
  isOverlayLoading.value = true;

  const { data: { values, error } } = await HttpClient.patch(
    `/v1/bookings/${booking.value!.id}/dates`,
    { endDate },
  );

  if (!error) {
    booking.value!.endDate = values.endDate;
    booking.value!.totalProfit = values.totalProfit;
  }

  isOverlayLoading.value = false;
};

onMounted(fetchData);
</script>